org.apache.maven.plugin.descriptor

## Class PluginDescriptor

- java.lang.Object
- - ComponentSetDescriptor
  - - org.apache.maven.plugin.descriptor.PluginDescriptor

    public class PluginDescriptor
    extends ComponentSetDescriptor

Version:
  $Id: PluginDescriptor.java 743587 2009-02-12 01:32:50Z jdcasey $
Author:
  Jason van Zyl

### Constructor Summary

Constructors
Constructor and Description
`PluginDescriptor()`

### Method Summary

Methods
`void` `addMojo(MojoDescriptor mojoDescriptor)`
`static java.lang.String` `constructPluginKey(java.lang.String groupId, java.lang.String artifactId, java.lang.String version)`
`boolean` `equals(java.lang.Object object)`
`java.lang.String` `getArtifactId()`
`java.util.Map` `getArtifactMap()`
`java.util.List` `getArtifacts()`
`ClassRealm` `getClassRealm()`
`static java.lang.String` `getDefaultPluginArtifactId(java.lang.String id)`
`static java.lang.String` `getDefaultPluginGroupId()`
`java.lang.String` `getDescription()`
`java.lang.String` `getGoalPrefix()`
`static java.lang.String` `getGoalPrefixFromArtifactId(java.lang.String artifactId)` Parse maven-...-plugin.
`java.lang.String` `getGroupId()`
`java.lang.String` `getId()`
`java.util.Set` `getIntroducedDependencyArtifacts()`
`Lifecycle` `getLifecycleMapping(java.lang.String lifecycle)`
`MojoDescriptor` `getMojo(java.lang.String goal)`
`java.util.List` `getMojos()`
`java.lang.String` `getName()`
`Artifact` `getPluginArtifact()`
`java.lang.String` `getPluginLookupKey()`
`java.lang.String` `getSource()`
`java.lang.String` `getVersion()`
`int` `hashCode()`
`boolean` `isInheritedByDefault()`
`void` `setArtifactId(java.lang.String artifactId)`
`void` `setArtifacts(java.util.List artifacts)`
`void` `setClassRealm(ClassRealm classRealm)`
`void` `setDescription(java.lang.String description)`
`void` `setGoalPrefix(java.lang.String goalPrefix)`
`void` `setGroupId(java.lang.String groupId)`
`void` `setInheritedByDefault(boolean inheritedByDefault)`
`void` `setIntroducedDependencyArtifacts(java.util.Set introducedDependencyArtifacts)`
`void` `setName(java.lang.String name)`
`void` `setPluginArtifact(Artifact pluginArtifact)`
`void` `setSource(java.lang.String source)`
`void` `setVersion(java.lang.String version)`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### PluginDescriptor

    public PluginDescriptor()

### Method Detail

#### getMojos

    public java.util.List getMojos()

#### addMojo

    public void addMojo(MojoDescriptor mojoDescriptor)
                 throws DuplicateMojoDescriptorException

Throws:
  `DuplicateMojoDescriptorException`

#### getGroupId

    public java.lang.String getGroupId()

#### setGroupId

    public void setGroupId(java.lang.String groupId)

#### getArtifactId

    public java.lang.String getArtifactId()

#### setArtifactId

    public void setArtifactId(java.lang.String artifactId)

#### constructPluginKey

    public static java.lang.String constructPluginKey(java.lang.String groupId,
                                      java.lang.String artifactId,
                                      java.lang.String version)

#### getPluginLookupKey

    public java.lang.String getPluginLookupKey()

#### getId

    public java.lang.String getId()

#### getDefaultPluginArtifactId

    public static java.lang.String getDefaultPluginArtifactId(java.lang.String id)

#### getDefaultPluginGroupId

    public static java.lang.String getDefaultPluginGroupId()

#### getGoalPrefixFromArtifactId

    public static java.lang.String getGoalPrefixFromArtifactId(java.lang.String artifactId)

Parse maven-...-plugin.

#### getGoalPrefix

    public java.lang.String getGoalPrefix()

#### setGoalPrefix

    public void setGoalPrefix(java.lang.String goalPrefix)

#### setVersion

    public void setVersion(java.lang.String version)

#### getVersion

    public java.lang.String getVersion()

#### setSource

    public void setSource(java.lang.String source)

#### getSource

    public java.lang.String getSource()

#### isInheritedByDefault

    public boolean isInheritedByDefault()

#### setInheritedByDefault

    public void setInheritedByDefault(boolean inheritedByDefault)

#### getArtifacts

    public java.util.List getArtifacts()

#### setArtifacts

    public void setArtifacts(java.util.List artifacts)

#### getArtifactMap

    public java.util.Map getArtifactMap()

#### equals

    public boolean equals(java.lang.Object object)

#### hashCode

    public int hashCode()

#### getMojo

    public MojoDescriptor getMojo(java.lang.String goal)

#### getLifecycleMapping

    public Lifecycle getLifecycleMapping(java.lang.String lifecycle)
                                  throws java.io.IOException,
                                         XmlPullParserException

Throws:
  `java.io.IOException`
  `XmlPullParserException`

#### setClassRealm

    public void setClassRealm(ClassRealm classRealm)

#### getClassRealm

    public ClassRealm getClassRealm()

#### setIntroducedDependencyArtifacts

    public void setIntroducedDependencyArtifacts(java.util.Set introducedDependencyArtifacts)

#### getIntroducedDependencyArtifacts

    public java.util.Set getIntroducedDependencyArtifacts()

#### setName

    public void setName(java.lang.String name)

#### getName

    public java.lang.String getName()

#### setDescription

    public void setDescription(java.lang.String description)

#### getDescription

    public java.lang.String getDescription()

#### getPluginArtifact

    public Artifact getPluginArtifact()

#### setPluginArtifact

    public void setPluginArtifact(Artifact pluginArtifact)